package de.accso.flexinale.ticketing.infrastructure.persistence;

import de.accso.flexinale.common.shared_kernel.Identifiable;
import de.accso.flexinale.common.shared_kernel.Versionable;
import de.accso.flexinale.ticketing.domain.model.Ticket;
import jakarta.persistence.EnumType;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.io.Serializable;

@jakarta.persistence.Entity(name="Ticket")
public class TicketEntity implements Identifiable, Versionable, Serializable {

    @jakarta.persistence.Id
    public String id;  // primary key

    public String filmId;

    public String vorfuehrungId;

    public String benutzerId;

    public boolean gueltig = true;

    @jakarta.persistence.Enumerated(EnumType.STRING)
    public Ticket.VerkaufsKanal verkaufsKanal;

    @jakarta.persistence.Version
    private Integer version = 0;

    protected TicketEntity() {
    }

    public TicketEntity(final String id, final Integer version,
                        final String filmId,
                        final String vorfuehrungId,
                        final String benutzerId,
                        final Ticket.VerkaufsKanal verkaufsKanal,
                        final boolean gueltig) {
        this.id = id;
        this.version = version;
        this.filmId = filmId;
        this.vorfuehrungId = vorfuehrungId;
        this.benutzerId = benutzerId;
        this.verkaufsKanal = verkaufsKanal;
        this.gueltig = gueltig;
    }

    @Override
    public Id id() {
        return Identifiable.Id.of(id);
    }

    @Override
    public Version version() {
        return Versionable.Version.of(version);
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) {return true;}

        if (o == null || getClass() != o.getClass()) {return false;}

        TicketEntity that = (TicketEntity) o;

        return new EqualsBuilder()
                .append(id, that.id).append(version, that.version)
                .append(filmId, that.filmId)
                .append(vorfuehrungId, that.vorfuehrungId).append(benutzerId, that.benutzerId)
                .append(verkaufsKanal, that.verkaufsKanal)
                .append(gueltig, that.gueltig)
                .isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37)
                .append(id).append(version)
                .append(filmId).append(vorfuehrungId).append(benutzerId)
                .append(verkaufsKanal)
                .append(gueltig)
                .toHashCode();
    }
}
